#define CLIENT_CONNECT		0x00000001
#define CLIENT_DISCONNECT	0x00000002
#define PROC_CREATE		0x00000004
#define PROC_EXIT		0x00000008
#define ERROR_MSG		0x00000010
#define LOG_MSG		        0x00000020
#define LOOKUP			0x00000040
#define LOG_ALL_MASK		0x0000007f


typedef unsigned long	Tick;


/*
 * Lookup Stats.
 */
typedef struct {
    int			client_id;      /* Which client made request. */
    Tick		service_time;	/* Time from select to finish service*/
    Tick	        lookup_time;	/* Time to lookup this request. */
    char		*db_name;	/* Database name. */
    char		*list_name;	/* Name of list. */
    char		lookup_type;	/* One of P, H, T, N */
    int			line_req;
    char		*prefix;
    int			lines_sent;
    int			reads;
    int			writes;
} LookupStats;



void			LogSetMask (char *optList);
void			LogSetRate (int rate);
void			LogSetDir (char *ld);
void			LogPrepareToFork (void);
void			LogPerror (char *msg);
int			LogClientConnect (unsigned int id, 
					  struct sockaddr_in *cli_addr);
void 			LogClientDiscon (unsigned int id, char *reason, 
					 int req_count);
int			LogProcCreate (int pid);
void			LogProcExit (int pid, char *reason);
void			LogLookup (LookupStats *ls);
void			LogOptions (void);
int			LogOpen (void);
void			LogClose (void);
void			LogFlush (void);
void			LogNewGeneration (void);
void			LogFOpenErr (int clientID, char *db_name, 
				char *list_name, char *f_name, int err_errno);
void			LogHeaderReadErr (char *db_name, char *list_name, 
				     char *hdr_name, int err_errno);
void			LogMsg (int type, char *comment);

Tick		GetTickCount (void);
